#ifndef __80211_h
#define __80211_h

#define 80211_ADDR_LEN        6
#define 80211_HDR_LEN         24

#define 80211_FTYPE_MGMT      0x00
#define 80211_FTYPE_CTL       0x04
#define 80211_FTYPE_DATA      0x08
#define 80211_FTYPE_MASK      0x0c

typedef struct  {
    int16 fc;
    int16 dur;
    uint8 a1[80211_ADDR_LEN];
    uint8 a2[80211_ADDR_LEN];
    uint8 a3[80211_ADDR_LEN];
    int16 seq;
} hdr_80211_t;


/* In file 80211.c: */
int enet_80211_send (struct mbuf *bpp, struct iface *iface, uint32 gateway, int prec, int del, int tput, int rel);
int enet_80211_output (struct iface *iface, const char *dest, char *source, int16 type,
	struct mbuf *data);
void eproc_80211 (struct iface *iface, struct mbuf *bp);

int ntoh80211(struct hdr_80211_t *hdr,struct mbuf **bpp);

#endif /* __80211_h */
