#ifndef	_APRS_H_
#define	_APRS_H_

/*
 * If you are compiling this source for JNOS (111f), then make
 * sure you define '-DJNOSAPRS' somewhere in your makefile, before
 * you actually compile the code. 07Sep2001, Maiko (VE4KLM).
 */

#ifdef	JNOSAPRS
#ifndef OPTIONAL
#define OPTIONAL
#endif
#endif

/*
 * APRS Services for JNOS 111x, TNOS 2.30 & TNOS 2.4x
 *
 * April,2001-February,2002 - Release # 1.11.2
 *
 * Designed and written by VE4KLM, Maiko Langelaar
 *
 * For non-commercial use (Ham Radio) only !!!
 *
 */
 
#include "udp.h"

#ifdef	APRSD

/* 24Aug2001, Maiko, We now have some compile time options */

/*
 * APRS_14501 - if you want TNOSaprs to service HTML 14501 pages, then
 *              make sure this one is defined. If you do not want this,
 *              or more importantly, if your system configuration is such
 *              that port 14501 is not accessible from the internet side,
 *              there is no point compiling this stuff in.
 */
#define	APRS_14501

/*
 * APRS_44825 - if you want TNOSaprs to service Client connections on
 *              port 14825, then make sure this one is defined. If you
 *              do not want this, or more importantly, if your system
 *              configuration is such that port 14825 is not accessible
 *              from the internet side, there is no point compiling
 *              this stuff in.
 */
#define	APRS_44825

/*
 * APRS_MIC_E - if you want TNOSaprs to recognize MIC-E packets, then
 *              make sure this one is defined. If you have no MIC-E
 *              systems in your area, then leave it undefined.
 *
 */
#define	APRS_MIC_E

/*
 * APRS_MSG_C - if you want to make the APRS Message Center
 *              available to your users then make sure this
 *              one is defined.
 */
#define	APRS_MSG_C

/* Software Version (Banner) Strings */

#ifdef	JNOSAPRS
/* This is the current release of JNOSaprs */
#define	TASVER "JNOSaprs 1.11.2"
#else
/* This is the current release of TNOSaprs */
#define	TASVER "TNOSaprs 1.11.2"
#endif

/* This is the APRS destination call we use for TNOSaprs */
#define	APRSDC "APZ111"

/* 28Nov2001, Generic default strings */
#define	APRSNOCALL "NOCALL"
#define	APRSNOPORT "NOPORT"

/* 28Nov2001, common externals */
extern int aprs_debug;

extern int aprsd_frame (struct udp *udp);
extern void aprsd_torf (struct iface *iface, struct mbuf *bp, struct ip *ip);

/* 16Aug2001, Maiko, Added 'iface' parameter */
extern int aprs_processing (struct ax25 *hdr,
	struct iface *iface, struct mbuf *bp);

extern int doaprsstat (int argc, char *argv[], void *p OPTIONAL);
extern void init_aprshrd (int);
extern void display_aprshrd (void);
extern int build_14501_aprshrd (char *dptr);

/* 17Oct2001, Maiko, New function to determine which interface APRS packet
 * was heard on
 */
extern const char *iface_hrd_on (char *callsign);

/* 16Aug2001, Maiko, Changed parameters so we have more info for stats */
extern void update_aprshrd (struct ax25 *hdr, struct iface *iface, char dti);

extern int aprs_mice (unsigned char*, unsigned char*, unsigned char*);
extern int get_topcnt (void);	/* 03Aug2001, for malloc of 14501 page */

extern void set_last_optout (void);	/* 20Aug2001, VE4KLM, statistics */

extern void aprslog (int s, const char *fmt,...);

/* 20Nov2001, VE4KLM, New dup function for duplicate APRS frames */
extern int aprs_dup (char *callsign, char *payload);

/* 27Nov2001, Maiko, Duplicate management commands */
extern int doaprsdup (int argc, char *argv[], void *p OPTIONAL);

/* 27Nov2001, Maiko, Moved broadcast functions into their own module */
extern int doaprsbc (int argc, char *argv[], void *p OPTIONAL);

/*
 * 28Nov2001, Maiko, This function now in aprsbc.o module.
 * 23Jan2002, Maiko, Split the old 'startigateident' function
 * into 2 new functions, one for Inet side, one for RF side,
 * also put in functions to allow us to stop the timers.
 *
 * extern void startigateident (void);
 */
extern void startinetbc (void);
extern void stopinetbc (void);
extern void startrfbc (void);
extern void stoprfbc (void);

/* 28Nov2001, Maiko, Some new functions to access
 * static variables in the aprssrv module. Needed
 * for new aprsbc module. Need better way to do it,
 * but it will work for now.
 */
extern int getAsocket (void);
extern int getHsocket (void);
extern const char *getaprsdestcall (void);
extern char *getlogoncall (void);
extern void update_outstats (int length);

/* 28Nov2001, Maiko, An external, now needed in aprsbc module */
extern int sendrf (char *data, int len);

/* 09Jan2002, Maiko, DTI validation function */
extern int valid_dti (char dti);

/* 11Jan2002, Maiko, More DTI data validation */
extern int valid_dti_data (char dti, char *data, int len);

extern int aprs_send (char *data, int len);

#endif

#endif
