#!/bin/sh

OSTYPE=`uname`
FILE=$1/autoexec/config.nos
AUTOEXEC=$1/autoexec.nos
WINSOCK=$1/autoexec/winsock.nos
ROUTES=$1/autoexec/routes.nos
D_DEFAULTPORT=none
D_SLIPPORT=none
export FILE AUTOEXEC WINSOCK D_DEFAULTPORT ROUTES D_SLIPPORT OSTYPE

echo "No autoexec.nos file was found, so TNOS will help you to"
echo "generate a initial one, with you answering only a couple"
echo "of questions"
echo ""



echo "#" >${FILE}
echo "# Automatically generated config.nos file" >>${FILE}
echo "#" >>${FILE}
echo "" >>${FILE}
echo "set D_NOSDIR $1" >>${FILE}


echo "#" >${AUTOEXEC}
echo "# Automatically generated autoexec.nos file" >>${AUTOEXEC}
echo "#" >>${AUTOEXEC}
echo "" >>${AUTOEXEC}
echo "source ${FILE}" >>${AUTOEXEC}
echo "source $1/autoexec/template.nos" >>${AUTOEXEC}


echo "Enter your Amateur Radio Callsign (D_CALLSIGN)?"
read ans
echo "set D_CALLSIGN $ans" >>${FILE}
echo "set D_HOSTNAME $ans.ampr.org" >>${FILE}
echo "set D_AX_OUTGOING $ans-15" >>${FILE}


echo "Enter the PBBS Heirarchial Address for your area (D_HADDR)?"
read ans
echo "set D_HADDR $ans" >>${FILE}


echo "Enter the Alias to use for your PBBS (D_PBBS_ALIAS)?"
read ans
echo "set D_PBBS_ALIAS $ans" >>${FILE}


echo "Enter the Sysop's Password (D_SYSOP_PASSWORD)?"
read ans
echo "set D_SYSOP_PASSWORD $ans" >>${FILE}


echo "Enter your AMPRNET IP address (D_AMPRIP)?"
read ans
echo "set D_AMPRIP $ans" >>${FILE}
D_AMPRIP=$ans

echo "Enter your AMPRNET Broadcast address (D_AMPR_BCAST)?"
read ans
echo "set D_AMPR_BCAST $ans" >>${FILE}
D_AMPR_BCAST=$ans

echo "Enter your AMPRNET Net Mask (D_AMPR_NMASK)?"
read ans
echo "set D_AMPR_NMASK $ans" >>${FILE}
D_AMPR_NMASK=$ans

echo "Enter the IP address of your DNS Server (D_DNS_SVR)?"
read ans
echo "set D_DNS_SVR $ans" >>${FILE}


echo "Enter the IP address of your SMTP Server (D_SMTP_GATEWAY)?"
read ans
echo "set D_SMTP_GATEWAY $ans" >>${FILE}


echo "Enter the name of your TNC serial port (if none, enter 'none') (D_PORT)?"
read ans
echo "set D_PORT $ans" >>${FILE}
if [ $ans != "none" ];
then
    echo "source $1/autoexec/tnc.nos" >>${AUTOEXEC}
    D_DEFAULTPORT=$ans
else
    echo "# D_PORT defined as 'none'" >>${AUTOEXEC}
    echo "# source $1/autoexec/tnc.nos" >>${AUTOEXEC}
fi


case $OSTYPE in
    CYGWIN* )
        if [ -x $1/winsock_list.exe ]; then
            $1/winsock_list.exe >${WINSOCK}
            echo "" >>${WINSOCK}
            echo "ifconfig win1 ipadd ${D_AMPRIP}" >>${WINSOCK}
            echo "ifconfig win1 broad ${D_AMPR_BCAST}" >>${WINSOCK}
            echo "ifconfig win1 net ${D_AMPR_NMASK}" >>${WINSOCK}
            echo "source ${WINSOCK}" >>${AUTOEXEC}
            echo "" >>${WINSOCK}
            echo "# end" >>${WINSOCK}
            D_DEFAULTPORT=win1
        else
            echo "# winsock_list.exe not found" >>${AUTOEXEC}
            echo "# source ${WINSOCK}" >>${AUTOEXEC}
        fi
        ;;
    * )
        echo "Enter the name of your SLIP port to the kernel (if none, enter 'none') (D_SLIPPORT)?"
        read ans
        echo "set D_SLIPPORT $ans" >>${FILE}
        if [ $ans != "none" ];
        then
            echo "source $1/autoexec/slip.nos" >>${AUTOEXEC}
            D_DEFAULTPORT=$ans
        else
            echo "# D_SLIPPORT defined as 'none'" >>${AUTOEXEC}
            echo "# source $1/autoexec/slip.nos" >>${AUTOEXEC}
        fi
        ;;
esac

echo "" >>${FILE}
echo "# end" >>${FILE}


echo "#" >${ROUTES}
echo "# Automatically generated autoexec/routes.nos file" >>${ROUTES}
echo "#" >>${ROUTES}
echo "" >>${ROUTES}
echo "route add default ${D_DEFAULTPORT}" >>${ROUTES}
echo "" >>${ROUTES}
echo "# end" >>${ROUTES}


echo "source ${ROUTES}" >>${AUTOEXEC}
echo "source $1/autoexec/clean.nos" >>${AUTOEXEC}

echo "" >>${AUTOEXEC}
echo "# And tell the world, that our work is complete!" >>${AUTOEXEC}
echo 'echo *** Processing: autoexec.nos complete on {$(ver s)} "   " {$(time)}' >>${AUTOEXEC}
echo "stats usage general" >>${AUTOEXEC}
echo "" >>${AUTOEXEC}
echo "# end" >>${AUTOEXEC}


cp -f $1/autoexec/autoconf/*.nos $1/autoexec

