#include "global.h"
#ifdef SCREENSAVER
#include "commands.h"
#include "session.h"

#if !defined(_lint)
static char rcsid[] OPTIONAL = "$Id: ssaver.c,v 1.1.1.1 2004/02/09 21:53:21 blantz Exp $";
#endif

extern unsigned char SCREENwidth;
extern unsigned char SCREENlength;
int32 LastIO;
static int32 ScreenSaver = 0;
static int ss_line, state, delayit, statline;

extern void statLineToggle (int clearmarquee);


#undef tputs
#undef newscreen
/*lint -save -e659 */
#undef newscreen
#ifdef HAVE_NCURSES_H
#include <ncurses.h>
#else
#include <curses.h>
#endif
/*lint -restore */
static WINDOW *saved;

extern int16 intrace;


#define DELAYVAL 2

void
screensaver ()
{
static short back, fore;

	if (!ScreenSaver)
		return;
	if (secclock() > (LastIO + ScreenSaver))	{
		if (!state)	{
			statline = Current->screen->statline;
			if (statline)
				statLineToggle (1);
			state = 1;
/* next line is a problem for linux version */
			swapscreen (Current, NULLSESSION);
			saved = newwin (SCREENlength, SCREENwidth, 0, 0);
			(void) pair_content (1, &fore, &back);
			(void) init_pair (1, COLOR_WHITE, COLOR_BLACK);
			wattrset (saved, COLOR_PAIR(1));
			(void) wbkgd (saved, COLOR_PAIR(1));
			(void) leaveok (saved, 1);
			ss_line = delayit = 0;
		}
		if (!delayit++)	{
			(void) werase (saved);
			(void) wmove (saved, ss_line++, 12);
			ss_line %= SCREENlength;
			(void) waddstr (saved, " TNOS Screen Saver Active... Press any key to continue ");
			(void) wrefresh (saved);
		}
		delayit %= DELAYVAL;
	} else if (state)	{
		(void) delwin (saved);
		swapscreen (NULLSESSION, Current);
		state = 0;
		_setcursortype (_NORMALCURSOR);
		(void) init_pair (1, fore, back);
		if (statline)
			statLineToggle(1);
	}
}

/* set the screen saver value */
int dossaver(int argc, char *argv[], void *p OPTIONAL)
{
	LastIO = secclock();
	return setlong(&ScreenSaver,"Screen Saver delay (seconds)",argc,argv);

}

void
sskick()
{

	if (!intrace && ScreenSaver)	{
		LastIO = secclock();
		if (state)
			screensaver();
	}
}

int
ssenabled ()
{
	return state;
}

#endif /* SCREENSAVER */

