Name: tnos-base
Distribution: Tampa NOS
Vendor: Brian A. Lantz
Version: RPMV
Release: RPMR
Group: Application/Ham
Copyright: Free for Amateur Radio and Educational purposes
AutoReqProv: no
Summary: TNOS RPMVRPMS Base Files, Executables and Sample Configuration Files
Prefix: /tnos
BuildRoot: /tmp

%description
---------------------------------------------------------------------

              Tampa NOS (TNOS) - Release RPMVRPMS

There are three packages available for TNOS. The first is the package
containing the source code for TNOS RPMVRPMS. The second is the package which
contains the documentation files (which are also included in the
first package).

This package contains all TNOS base files, executables (for Linux)
sample configuration files and documentation files.

To install this package at the default location of /tnos, you do:

	rpm -i tnos-base-RPMV-RPMR.i386.rpm

To install this package at some other location than /tnos, you do:

	rpm -i --prefix <dir> tnos-base-RPMV-RPMR.i386.rpm

where <dir> is replaced by the complete pathname of the directory that
you would like TNOS installed. The directory will be created, if it doesn't
already exist.

To install this base package on an OS other than Linux, add
'--ignorearch --ignoreos' to the command line. You can then delete or
replace the Linux executables with ones you compile from the source files.

---------------------------------------------------------------------

%install
if [ -e /tmp/tnos ]
then
	rm -r /tmp/tnos
fi
ln -s /dos/nos.lnx /tmp/tnos

%clean
rm -rf /tmp/tnos

%pre
echo ""
echo Welcome to TNOS RPMVRPMS!
echo ""
echo "Installing TNOS RPMVRPMS in directory: ${RPM_INSTALL_PREFIX}"

%post
echo ""
echo "Installation of TNOS RPMVRPMS complete!"

%preun
echo ""
echo "Uninstalling TNOS RPMVRPMS..."

%postun
rm -rf ${RPM_INSTALL_PREFIX}
echo "Uninstallation of TNOS RPMVRPMS complete!"

%files
/tnos/buildctl
/tnos/cnvfwd
/tnos/ctlcheck
%docdir /tnos/doc/
/tnos/doc/
%config /tnos/etc/areas
%config /tnos/etc/areas.sys
%config /tnos/etc/askhome.dat
/tnos/etc/catalog.cat
/tnos/etc/config.cfg
%config /tnos/etc/expire.dat
%config /tnos/etc/forward.bbs
%config /tnos/etc/ftpmotd
/tnos/etc/help/
%config /tnos/etc/motd
%config /tnos/etc/newuser
%config /tnos/etc/quotes
%config /tnos/etc/rewrite
/tnos/features.new
%dir /tnos/finger/
/tnos/man/
/tnos/mksetup.tcl
%dir /tnos/public/
/tnos/readme
/tnos/setup.in
/tnos/spool/
/tnos/startnos
/tnos/tnos
/tnos/tnos-x/

