/* *SIMPLE* program to decode the TNOS Features Flags from the
   Features Map produced by 'tnos -m'
 */

 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "map.h"


#define CHECKFOR(y)	if (string[y##_OFF] & y##_VAL)	printf (format, #y); \
			else if (format2 != NULLCHAR)	printf (format2, #y)

#define PLAIN	0
#define HEADER	1
#define CONFIG	2

#define CMDLINE 0
#define SYSTEM  1

#define NULLFILE ((FILE *) 0)
#define NULLCHAR ((char *) 0)

unsigned char string[MAPLENGTH + 3];

char const *format = "%s\n";
char const *format2 = NULLCHAR;
char const *formatnum = "%s=%d\n";

int
main (int argc, char *argv[])
{
int theindex = 1;
char *tmp = NULLCHAR;
unsigned char *cp;
char buf[3];
int ch;
int mode = PLAIN;
int input = CMDLINE;
char sysbuf[1024];
char syscmd[1024];
FILE *fp;
    
    string[MAPLENGTH] = 20;
    string[MAPLENGTH + 1] = 40;
    string[MAPLENGTH + 2] = 0;
    if (argc > 2 && !strcmp (argv[1], "-f"))    {
        input = SYSTEM;
        sprintf (syscmd, "%s -m >nerf", argv[2]);
        system (syscmd);
        sysbuf[0] = 0;
        fp = fopen ("nerf", "r");
        if (fp != NULLFILE) {
            fgets (sysbuf, 1024, fp);
            fclose (fp);
            unlink ("nerf");
            tmp = &sysbuf[14];
        }
        argc -= 2;
        ++argv;
        ++argv;
    }
    if (argc > 1 && !strcmp (argv[1], "-c"))	{
		format = "set %s y\n";
		format2 = "set %s n\n";
		formatnum = "set %s %d\n";
		argc--;
		++argv;
		mode = CONFIG;
	} else if (argc > 1 && !strcmp (argv[1], "-h"))	{
		format = "#define %s\t1\n";
		format2 = "#undef %s\n";
		formatnum = "#define %s\t%d\n";
		argc--;
		++argv;
		mode = HEADER;
	}
    if (tmp == NULLCHAR && argc == 1) {
        printf ("Usage: tnosmap [-f <tnosexe>] [-c|-h] [Features map:] <mapstr>\n");
        exit (-1);
    }

    if (argc == 4 && !strcmp (argv[1], "Features") && !strcmp (argv[2], "map:"))
		theindex = 3;
    
    if (tmp == NULLCHAR)
        tmp = argv[theindex];
	cp = string;
	while (*tmp)	{
		buf[0] = *tmp++;
		buf[1] = *tmp++;
		buf[2] = 0;
		sscanf (buf, "%x", &ch);
		*cp++ = ch;
	}

	CHECKFOR(ALERTMONITOR);
	CHECKFOR(ALLCMD);
	CHECKFOR(ALLSERV);
	CHECKFOR(ALLSESSIONS);
	CHECKFOR(ALTERBID);
	CHECKFOR(APRSD);
	CHECKFOR(ASKHOME);
	CHECKFOR(ASY);
	CHECKFOR(ATCMD);
	CHECKFOR(AUTOROUTE);
	CHECKFOR(AXBCSTR);
	CHECKFOR(AXIP);
	CHECKFOR(AXUDP);
	CHECKFOR(AXUI);
	CHECKFOR(BBSEXPORT);
	CHECKFOR(BBSIMPORT);
	CHECKFOR(BOOTPCLIENT);
	CHECKFOR(BOOTPSERVER);
	CHECKFOR(BROWSER);
	CHECKFOR(CALLBOOK);
	CHECKFOR(CALLCLI);
	CHECKFOR(CATALOG);
	CHECKFOR(CONVERS);
	CHECKFOR(CRONTAB);
	CHECKFOR(DELEGATE);
	CHECKFOR(DIALER);
	CHECKFOR(DSERVER);
	CHECKFOR(EDITHEADERS);
	CHECKFOR(ENCAP);
	CHECKFOR(ESCAPE);
	CHECKFOR(EXPIRY);
	CHECKFOR(FBBCMP);
	CHECKFOR(FBBFWD);
	CHECKFOR(FIFOSERVER);
	CHECKFOR(FILECMDS);
	CHECKFOR(FOQ_CMDS);
	CHECKFOR(FORTH);
	CHECKFOR(FTPTDISC);
	CHECKFOR(GATECMDS);
	CHECKFOR(GPS);
	CHECKFOR(HOLDMODS);
	CHECKFOR(HOLDMONITOR);
	CHECKFOR(HOPCHECK);
	CHECKFOR(HOPPER);
	CHECKFOR(HTTPPBBS);
	CHECKFOR(HTTPCGI);
	CHECKFOR(HTTP);
	CHECKFOR(IPACCESS);
	CHECKFOR(KISS);
	CHECKFOR(KERNEL_IF);
	CHECKFOR(LOCK);
	CHECKFOR(LOG_GMT_TZ);
	CHECKFOR(LOOKSESSION);
	CHECKFOR(LZW);
	CHECKFOR(MAILBOX);
	CHECKFOR(MAILCMDS);
	CHECKFOR(MAILFILTER);
	CHECKFOR(MAILFOR);
	CHECKFOR(MBFWD);
	CHECKFOR(MBXTDISC);
	CHECKFOR(MESSAGESERVER);
	CHECKFOR(MONITOR);
	CHECKFOR(NETROM);
	CHECKFOR(NNTPFILTER);
	CHECKFOR(NNTPS);
	CHECKFOR(NNTP);
	CHECKFOR(NODECALL);
	CHECKFOR(NR4TDISC);
	CHECKFOR(NRS);
	CHECKFOR(PING_SECURE);
	CHECKFOR(POLLEDKISS);
	CHECKFOR(POOLED);
	CHECKFOR(POP2CLIENT);
	CHECKFOR(POP2SERVER);
	CHECKFOR(POP3CLIENT);
	CHECKFOR(POP3SERVER);
	CHECKFOR(POP);
	CHECKFOR(PPP);
	CHECKFOR(QRZCALLB);
	CHECKFOR(RARP);
	CHECKFOR(RDATE);
	CHECKFOR(REJECT);
	CHECKFOR(REQSVR);
	CHECKFOR(RIP);
	CHECKFOR(RLINE);
	CHECKFOR(RLOGINCLI);
	CHECKFOR(RLOGINSERV);
	CHECKFOR(RMAIL);
	CHECKFOR(ROUTESERVER);
	CHECKFOR(RSPF);
	CHECKFOR(RXECHO);
	CHECKFOR(SCREENSAVER);
	CHECKFOR(SCRIPTING);
	CHECKFOR(SERVERS);
	CHECKFOR(SETPSINFO);
	CHECKFOR(SHELL);
	CHECKFOR(SLIP);
	CHECKFOR(SM_CURSES);
	CHECKFOR(SM_DUMB);
	CHECKFOR(SM_RAW);
	CHECKFOR(SOUNDS);
	CHECKFOR(SQL);
	CHECKFOR(STATS_AREA);
	CHECKFOR(STATS_FWD);
	CHECKFOR(STATS_HTTP);
	CHECKFOR(STATS_MSG);
	CHECKFOR(STATS);
	CHECKFOR(STATS_TFC);
	CHECKFOR(STATS_USE);
	CHECKFOR(STRICT_CALL);
	CHECKFOR(STRICT_AX25CALL);
	CHECKFOR(STRICT_HTTPCALL);
	CHECKFOR(TCPACCESS);
	CHECKFOR(TCPGATE);
	CHECKFOR(TERMSERVER);
	CHECKFOR(TIPMAIL);
	CHECKFOR(TRACESERVER);
	CHECKFOR(TRACE);
	CHECKFOR(TRANSLATE);
	CHECKFOR(TSCRIPTSERVER);
	CHECKFOR(TTYCALL);
	CHECKFOR(TUTOR);
	CHECKFOR(UDPACCESS);
	CHECKFOR(UKIP);
	CHECKFOR(UNIX_SOCKETS);
	CHECKFOR(USEPOP3);
	CHECKFOR(USERLOG);
	CHECKFOR(USE_TZOFFSET);
	CHECKFOR(VERSION_ON_FILE);
	CHECKFOR(VJCOMPRESS);
	CHECKFOR(WINSOCK);
	CHECKFOR(WPAGES);
	CHECKFOR(XFWD);
	CHECKFOR(XMODEM);
	CHECKFOR(XSERVER);

	printf (formatnum, "NSESSIONS", string[MAPLENGTH]);
	printf (formatnum, "DEFNSOCK", string[MAPLENGTH + 1]);
    return 0;
}
