#include <stdio.h>
#include <windows.h>
#define _WINSOCK2_H
#include <sys/socket.h>
#include "packet32.h"
#include "ntddndis.h"

#define Max_Num_Adapter 10
#define NULLCHAR ((char*)0)

char AdapterList[Max_Num_Adapter][1024];
char uni[1024];
int AdapterNum=0;

extern BOOLEAN PacketGetAdapterNames(PTSTR pStr,PULONG  BufferSize);
void getAdapterList (void);
void convertUnicode (char *orig);


void convertUnicode (char *orig)
{
    char *u = uni;
    
    while (1) {
        if (!*orig)
            break;
        *u++ = *orig;
        orig += 2;
    }
    *u = 0;
}

void getAdapterList (void)
{
    int i = 0;

    DWORD dwVersion;
    DWORD dwWindowsMajorVersion;

    //unicode strings (winnt)
    WCHAR AdapterName[8192]; // string that contains a list of the network adapters
    WCHAR *temp,*temp1;

    //ascii strings (win95)
    char AdapterNamea[8192]; // string that contains a list of the network adapters
    char *tempa,*temp1a;

    ULONG AdapterLength = 4096;
	
    // obtain the name of the adapters installed on this machine

    // the data returned by PacketGetAdapterNames is different in Win95 and in WinNT.
    // We have to check the os on which we are running
    dwVersion=GetVersion();
    dwWindowsMajorVersion =  (DWORD)(LOBYTE(LOWORD(dwVersion)));
    if (!(dwVersion >= 0x80000000 && dwWindowsMajorVersion >= 4)) {
        // Windows NT
	if(PacketGetAdapterNames((char *)AdapterName,&AdapterLength)==FALSE) {
            printf("Unable to retrieve the list of the adapters!\n");
            return;
	}
	temp=AdapterName;
	temp1=AdapterName;
	while ((*temp!='\0')||(*(temp-1)!='\0')) {
            if (*temp=='\0') {
                convertUnicode ((char *)temp1);
		memcpy(AdapterList[i],uni, strlen (uni));
		temp1=temp+1;
		i++;
            }
            temp++;
	}
	  
    } else {	//windows 95
	if(PacketGetAdapterNames(AdapterNamea,&AdapterLength)==FALSE){
            printf("Unable to retrieve the list of the adapters!\n");
            return;
	}
	tempa=AdapterNamea;
	temp1a=AdapterNamea;

	while ((*tempa!='\0')||(*(tempa-1)!='\0')) {
            if (*tempa=='\0') {
                memcpy(AdapterList[i],temp1a,tempa-temp1a);
		temp1a=tempa+1;
		i++;
            }
            tempa++;
	}
		  
    }
    AdapterNum=i;
}

int main()
{
int i;
int bad = 0;
int cnt = 0;
char *cp;
int AdapterStat[Max_Num_Adapter];
    
    getAdapterList ();
    for (i = 0; i < AdapterNum; i++) {
        cp = strchr (AdapterList[i], '{');
        if (cp == NULLCHAR) {
            AdapterStat[i] = 0;
            bad++;
        } else {
            AdapterStat[i] = 1;
            cnt++;
        }
    }
    if (bad > 0) {
        printf ("# The following device%s exists, but shouldn't be used....\n", (bad > 1) ? "s" : "");
        for (i = 0; i < AdapterNum; i++) {
            if (AdapterStat[i] == 0)
                printf ("#\t%s\n", AdapterList[i]);
        }
        printf ("#\n");
    }
    if (cnt > 1)
        printf ("# Either of these interfaces could work, just takes trial....\n");
    cnt = 1;
    for (i = 0; i < AdapterNum; i++) {
        if (AdapterStat[i] == 1)
            printf ("attach winsock win%d %s\n", cnt++, AdapterList[i]);
    }

    return (0);
}


